#include <asm/unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <asm/signal.h>
#include <sys/time.h>

pid_t waitpid(pid_t, int *, int);
void (*signal(int, void (*)(int)))(int);
int execve(const char *, char *const [], char *const []) __attribute__(( __noreturn__ ));
void exit(int) __attribute__(( __noreturn__ ));
pid_t fork(void);
int pause(void);

extern char str_rcS;
extern char str_rcM;
extern char str_rc6;
extern char str_inetd;

int run(const char *program, const char **args, const int wait)
{
	char	*e[2];
	pid_t	pid;

	if ((pid = fork()) == 0)
	{
		e[0] = NULL;
		execve(program,(char **)args,(char **)e);
	}
	if (wait)
	{
		/*
		 *  at this stage, size is more important
		 */
		waitpid(pid,NULL,0);
	}
	return(pid);
}

void sigchld(int sig)
{
	waitpid(-1,NULL,WNOHANG);
	signal(SIGCHLD,sigchld);
}

void _start(void) __attribute__(( __noreturn__ ));
void _start(void)
{
	char *pparm[2];

	sigchld(0);

	pparm[0] = &str_rcS;
	pparm[1] = NULL;

	run(&str_rcS,(const char **)pparm,1);

	pparm[0] = &str_rcM;
	pparm[1] = NULL;

	run(&str_rcM,(const char **)pparm,1);

	pparm[0] = &str_inetd;
	pparm[1] = NULL;

	run(&str_inetd,(const char**)pparm,0);

	for(;;)
		pause();
}
